'From Squeak2.8 of 13 June 2000 [latest update: #2359] on 27 February 2001 at 4:24:07 pm'!
Model subclass: #TestRunner
	instanceVariableNames: 'result details passFail failures errors tests testSuite passFailText detailsText lastPass testsList selectedFailureTest selectedErrorTest selectedSuite '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!TestCase methodsFor: 'Running' stamp: 'rew 2/26/2001 22:04'!
openDebuggerOnFailingTestMethod
	"SUnit has halted one step in front of the failing test method. 
	Step over the 'self halt' and send into 'self perform: testSelector' 
	to see the failure from the beginning"

	"self halt."
	self perform: testSelector sunitAsSymbol! !


!TestRunner methodsFor: 'constants' stamp: 'rew 2/27/2001 15:59'!
windowLabel

	^'SUnit Camp Smalltalk 2.7.2 Test Runner'! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 20:44'!
debugErrorTest: anInteger
	selectedErrorTest _ anInteger.  "added rew"
	selectedFailureTest _ 0.			"added rew"
	self changed: #selectedFailureTest.		"added rew"
	self changed: #selectedErrorTest.		"added rew"
	(anInteger ~= 0)
		ifTrue: [(result errors at: anInteger) debug]! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 21:49'!
debugFailureTest: anInteger

	(anInteger ~= 0)
		ifTrue: [(result failures at: anInteger) debugAsFailure].

	selectedFailureTest _ anInteger.
	selectedErrorTest _ 0.
	self changed: #selectedErrorTest.
	self changed: #selectedFailureTest.
! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 20:47'!
refreshTests
	tests _ (TestCase allSubclasses collect: [:each | each name]) asOrderedCollection.
	self changed: #tests.
	testSuite := nil.
	selectedSuite _ 0.
	selectedFailureTest _ 0.
	selectedErrorTest _ 0.
	self changed: #selectedFailureTest.		"added rew"
	self changed: #selectedErrorTest.		"added rew" 
	self changed: #selectedSuite.
	self refreshWindow! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 21:06'!
runOneTest
	Cursor execute showWhile: 
		[testSuite notNil
			ifTrue: 
				[self runWindow.
				result _ (TestSuitesScripter run: testSuite) run.
				self updateWindow: result]
			ifFalse: 
				[self runWindow.
				self displayPassFail: 'No Test Suite Selected']]! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 21:05'!
runTests
	Cursor execute showWhile: 
		[self runWindow.
		result _ self suite run.
		self updateWindow: result]! !

!TestRunner methodsFor: 'processing' stamp: 'rew 5/15/2000 21:08'!
selectedErrorTest
	^selectedErrorTest! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 21:01'!
selectedFailureTest

	^selectedFailureTest! !

!TestRunner methodsFor: 'processing' stamp: 'rew 5/15/2000 21:08'!
selectedSuite

	^selectedSuite! !

!TestRunner methodsFor: 'processing' stamp: 'rew 8/23/2000 20:52'!
selectedSuite: anInteger 
	anInteger ~= 0 ifTrue: [testSuite _ tests at: anInteger].
	selectedSuite _ selectedSuite = anInteger
					ifTrue:[0]
					ifFalse:[anInteger].
	selectedFailureTest _ 0.
	selectedErrorTest _ 0.
	self changed: #selectedFailureTest.		"added rew"
	self changed: #selectedErrorTest.		"added rew" 
	self changed: #selectedSuite.! !

!TestRunner methodsFor: 'interface opening' stamp: 'SSS 7/5/2000 14:21'!
open
	"TestRunner new open"
	"=== build the parts ... ==="
	| topWindow runButton errorsList failuresList runOneButton refreshButton debugButton |
	(topWindow _ StandardSystemView new) label: self windowLabel;
	 model: self.
	runButton _ PluggableButtonView
				on: self
				getState: #runButtonState
				action: #runTests
				label: #runButtonLabel.
	runButton label: self runButtonLabel;
	 insideColor: self runButtonColor.
	runOneButton _ PluggableButtonView
				on: self
				getState: #runButtonState
				action: #runOneTest
				label: #runOneButtonLabel.
	runOneButton label: self runOneButtonLabel;
	 clearInside: self runButtonColor;
	 insideColor: self runButtonColor.
	refreshButton _ PluggableButtonView
				on: self
				getState: #refreshButtonState
				action: #refreshTests
				label: #refreshButtonLabel.
	refreshButton label: self refreshButtonLabel;
	 clearInside: self runButtonColor;
	 insideColor: self runButtonColor.
	debugButton _ PluggableButtonView
				on: self
				getState: #debugState
				action: #debugTest
				label: #debugButtonLabel.
	debugButton label: self debugButtonLabel;
	 clearInside: self runButtonColor;
	 insideColor: self runButtonColor.
	passFailText _ PluggableTextView
				on: self
				text: #passFail
				accept: nil.
	detailsText _ PluggableTextView
				on: self
				text: #details
				accept: nil.
	testsList _ PluggableListView
				on: self
				list: #tests
				selected: nil
				changeSelected: #selectedSuite:.
	failuresList _ PluggableListView
				on: self
				list: #failures
				selected: nil
				changeSelected: #debugFailureTest:.
	errorsList _ PluggableListView
				on: self
				list: #errors
				selected: nil
				changeSelected: #debugErrorTest:.
	"=== size the parts ... ==="
	runButton borderWidth: 1;
	 window: (0 @ 0 corner: 20 @ 15).
	runOneButton borderWidth: 1;
	 window: (0 @ 0 corner: 20 @ 15).
	refreshButton borderWidth: 1;
		window: (0 @ 0 corner: 20 @ 30).
	passFailText borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 10).
	detailsText borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 10).
	testsList borderWidth: 1;
	 	window: (0 @ 0 corner: 60 @ 30).
	failuresList borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 30).
	errorsList borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 30).
"	debugButton borderWidth: 1;
		window: (0 @ 0 corner: 20 @ 60)."
	"=== assemble the whole ... ==="
	topWindow addSubView: refreshButton.
	topWindow addSubView: testsList toRightOf: refreshButton.
	topWindow addSubView: runOneButton toRightOf: testsList.
	topWindow addSubView: runButton below: runOneButton.
	topWindow addSubView: passFailText below: refreshButton.
	topWindow addSubView: detailsText below: passFailText.
	topWindow addSubView: failuresList below: detailsText.
	topWindow addSubView: errorsList below: failuresList.
	"=== open it ... ==="
	topWindow minimumSize: 200 @ 200.
	topWindow controller open! !

!TestRunner methodsFor: 'interface opening' stamp: 'rew 8/23/2000 21:44'!
openAsMorph
	"TestRunner new openAsMorph"
	"=== build the parts ... ==="
	| topWindow runButton errorsList failuresList runOneButton refreshButton |
	Smalltalk isMorphic
		ifFalse: [^self open].
	(topWindow _ SystemWindow labelled: self windowLabel) model: self.
	runButton _ PluggableButtonMorph
				on: self
				getState: #runButtonState
				action: #runTests
				label: #runButtonLabel.
	runButton color: self runButtonColor.
	runButton onColor: self runButtonColor offColor: self runButtonColor.
	runOneButton _ PluggableButtonMorph
				on: self
				getState: #runButtonState
				action: #runOneTest
				label: #runOneButtonLabel.
	runOneButton color: self runButtonColor.
	runOneButton onColor: self runButtonColor offColor: self runButtonColor.
	refreshButton _ PluggableButtonMorph
				on: self
				getState: #refreshButtonState
				action: #refreshTests
				label: #refreshButtonLabel.
	refreshButton color: self runButtonColor.
	refreshButton onColor: self runButtonColor offColor: self runButtonColor.
	passFailText _ PluggableTextMorph
				on: self
				text: #passFail
				accept: nil.
	passFailText retractable: true.
	detailsText _ PluggableTextMorph
				on: self
				text: #details
				accept: nil.
	detailsText retractable: true.
	testsList _ PluggableListMorph
				on: self
				list: #tests
				selected: #selectedSuite
				changeSelected: #selectedSuite:.
	testsList autoDeselect: false.
	failuresList _ PluggableListMorph
				on: self
				list: #failures
				selected: #selectedFailureTest	
				changeSelected: #debugFailureTest:.
	errorsList _ PluggableListMorph
				on: self
				list: #errors
				selected: #selectedErrorTest
				changeSelected: #debugErrorTest:.
	"=== assemble the whole ... ==="
	topWindow addMorph: refreshButton frame: (0.0 @ 0.0 extent: 0.2 @ 0.2).
	topWindow addMorph: testsList frame: (0.2 @ 0.0 extent: 0.6 @ 0.2).
	topWindow addMorph: runOneButton frame: (0.8 @ 0.0 extent: 0.2 @ 0.1).
	topWindow addMorph: runButton frame: (0.8 @ 0.1 extent: 0.2 @ 0.1).
	topWindow addMorph: passFailText frame: (0.0 @ 0.2 extent: 1.0 @ 0.1).
	topWindow addMorph: detailsText frame: (0.0 @ 0.3 extent: 1.0 @ 0.1).
	topWindow addMorph: failuresList frame: (0.0 @ 0.4 extent: 1.0 @ 0.3).
	topWindow addMorph: errorsList frame: (0.0 @ 0.7 extent: 1.0 @ 0.3).
	"=== open it ... ==="
	topWindow openInWorldExtent: 400 @ 200.
	self refreshWindow.
	^ topWindow! !

!TestRunner methodsFor: 'initialize' stamp: 'rew 8/23/2000 20:57'!
initialize
	result _ TestResult new.
	passFail _ 'N/A'.
	details _ '...'.
	failures _ OrderedCollection new.
	errors _ OrderedCollection new.
	tests _ (TestCase allSubclasses collect: [:each | each name]) asOrderedCollection.
	selectedSuite _ 0.
	selectedFailureTest _ 0.
	selectedErrorTest _ 0.
! !

