'From Squeak2.8 of 13 June 2000 [latest update: #2359] on 23 August 2000 at 10:36:48 pm'!
Object subclass: #TestCase
	instanceVariableNames: 'testSelector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core'!
TestCase class
	instanceVariableNames: ''!
Object subclass: #TestResult
	instanceVariableNames: 'runCount failures errors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core'!
TestResult class
	instanceVariableNames: ''!
Object subclass: #TestSuite
	instanceVariableNames: 'tests '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core'!
Object subclass: #TestSuitesScripter
	instanceVariableNames: 'script stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core'!
TestSuitesScripter class
	instanceVariableNames: ''!

!TestCase methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 12:50'!
assert: aBoolean
	aBoolean ifFalse: [self signalFailure: 'Assertion failed']! !

!TestCase methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 12:50'!
deny: aBoolean
	self assert: aBoolean not! !

!TestCase methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 12:50'!
should: aBlock
	self assert: aBlock value! !

!TestCase methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 12:51'!
should: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)! !

!TestCase methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 12:51'!
shouldnt: aBlock
	self deny: aBlock value! !

!TestCase methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 12:51'!
shouldnt: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not! !

!TestCase methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 12:52'!
signalFailure: aString
	TestResult failure sunitSignalWith: aString
! !

!TestCase methodsFor: 'Dependencies' stamp: 'SSS 7/3/2000 12:52'!
addDependentToHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"
! !

!TestCase methodsFor: 'Dependencies' stamp: 'SSS 7/3/2000 12:53'!
removeDependentFromHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"
! !

!TestCase methodsFor: 'Printing' stamp: 'SSS 7/3/2000 12:54'!
printOn: aStream
	aStream nextPutAll: self class printString.
	aStream nextPutAll: '>>'.
	aStream nextPutAll: testSelector! !

!TestCase methodsFor: 'Private' stamp: 'SSS 7/3/2000 12:55'!
executeShould: aBlock inScopeOf: anExceptionalEvent 
	[[aBlock value]
		sunitOn: anExceptionalEvent
		do: [:ex | ^true]]
			sunitOn: TestResult error
			do: [:ex | ^false].
	^false.! !

!TestCase methodsFor: 'Private' stamp: 'SSS 7/3/2000 12:55'!
setTestSelector: aSymbol
	testSelector := aSymbol! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:55'!
debug
	(self class selector: testSelector) runCase! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:56'!
debugAsFailure
	(self class selector: testSelector) runCaseAsFailure! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:56'!
openDebuggerOnFailingTestMethod
	"SUnit has halted one step in front of the failing test method. 
	Step over the 'self halt' and send into 'self perform: testSelector' 
	to see the failure from the beginning"

	self halt.
	self perform: testSelector sunitAsSymbol! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:56'!
run
	| result |
	result := TestResult new.
	self run: result.
	^result! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:57'!
run: aResult
	aResult runCase: self! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:57'!
runCase
	self setUp.
	[self perform: testSelector sunitAsSymbol] sunitEnsure: [self tearDown]! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:57'!
runCaseAsFailure
	self setUp.
	[[self openDebuggerOnFailingTestMethod] sunitEnsure: [self tearDown]] fork! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:57'!
setUp! !

!TestCase methodsFor: 'Running' stamp: 'SSS 7/3/2000 12:57'!
tearDown! !


!TestCase class methodsFor: 'Instance Creation' stamp: 'SSS 7/3/2000 12:58'!
debug: aSymbol
	^(self selector: aSymbol) debug! !

!TestCase class methodsFor: 'Instance Creation' stamp: 'SSS 7/3/2000 12:58'!
run: aSymbol
	^(self selector: aSymbol) run! !

!TestCase class methodsFor: 'Instance Creation' stamp: 'SSS 7/3/2000 12:59'!
selector: aSymbol
	^self new setTestSelector: aSymbol! !

!TestCase class methodsFor: 'Instance Creation' stamp: 'SSS 7/3/2000 12:59'!
suite
	| testSelectors result |
	testSelectors := self sunitSelectors select: [:each | 'test*' sunitMatch: each].
	result := TestSuite new.
	testSelectors do: [:each | result addTest: (self selector: each)].
	^result! !


!TestResult methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:01'!
correctCount
	^self runCount - self failureCount - self errorCount! !

!TestResult methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:01'!
defects
	^self errors, self failures! !

!TestResult methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:01'!
errorCount
	^self errors size! !

!TestResult methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:01'!
errors
	errors isNil ifTrue: [errors := OrderedCollection new].
	^errors! !

!TestResult methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:02'!
failureCount
	^self failures size! !

!TestResult methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:02'!
failures
	failures isNil ifTrue: [failures := OrderedCollection new].
	^failures! !

!TestResult methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:02'!
runCount
	^runCount! !

!TestResult methodsFor: 'Init / Release' stamp: 'SSS 7/3/2000 13:03'!
initialize
	runCount := 0! !

!TestResult methodsFor: 'Printing' stamp: 'SSS 7/3/2000 13:03'!
printOn: aStream
	aStream
		nextPutAll: self runCount printString;
		nextPutAll: ' run, ';
		nextPutAll: self failureCount printString;
		nextPutAll: ' failed, ';
		nextPutAll: self errorCount printString;
		nextPutAll:' error'.
	self errorCount ~= 1
		ifTrue: [aStream nextPut: $s].! !

!TestResult methodsFor: 'Running' stamp: 'SSS 7/3/2000 13:03'!
runCase: aTestCase
	runCount := runCount + 1.
	[[aTestCase runCase] 
		sunitOn: self class failure
		do: 
			[:signal | 
			self failures add: aTestCase.
			signal sunitExitWith: nil]]
			sunitOn: self class error
			do:
				[:signal |
				self errors add: aTestCase.
				signal sunitExitWith: nil]! !

!TestResult methodsFor: 'Testing' stamp: 'SSS 7/3/2000 13:04'!
hasPassed
	^self runCount = self correctCount! !

!TestResult methodsFor: 'Testing' stamp: 'SSS 7/3/2000 13:04'!
isFailure: aTestCase
	^self failures includes: aTestCase! !


!TestResult class methodsFor: 'Exceptions' stamp: 'SSS 7/3/2000 13:05'!
error
	^self exError! !

!TestResult class methodsFor: 'Exceptions' stamp: 'SSS 7/3/2000 13:06'!
exError
	"Change for Dialect"
	^ Error! !

!TestResult class methodsFor: 'Exceptions' stamp: 'SSS 7/3/2000 13:06'!
failure
	^TestFailure! !

!TestResult class methodsFor: 'Exceptions' stamp: 'SSS 7/3/2000 13:06'!
signalErrorWith: aString 
	self error sunitSignalWith: aString! !

!TestResult class methodsFor: 'Exceptions' stamp: 'SSS 7/3/2000 13:07'!
signalFailureWith: aString 
	self failure sunitSignalWith: aString! !

!TestResult class methodsFor: 'Init / Release' stamp: 'SSS 7/3/2000 13:07'!
new
	^super new initialize! !


!TestSuite methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:09'!
addTest: aTest
	self tests add: aTest! !

!TestSuite methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:10'!
addTests: aCollection 
	aCollection do: [:eachTest | self addTest: eachTest]! !

!TestSuite methodsFor: 'Accessing' stamp: 'SSS 7/3/2000 13:10'!
tests
	tests isNil ifTrue: [tests := OrderedCollection new].
	^tests! !

!TestSuite methodsFor: 'Dependencies' stamp: 'SSS 7/3/2000 13:11'!
addDependentToHierachy: anObject
	self sunitAddDependent: anObject.
	self tests do: [ :each | each addDependentToHierachy: anObject]! !

!TestSuite methodsFor: 'Dependencies' stamp: 'SSS 7/3/2000 13:11'!
removeDependentFromHierachy: anObject
	self sunitRemoveDependent: anObject.
	self tests do: [ :each | each removeDependentFromHierachy: anObject]! !

!TestSuite methodsFor: 'Running' stamp: 'SSS 7/3/2000 13:12'!
run
	| result |
	result := TestResult new.
	self run: result.
	^result! !

!TestSuite methodsFor: 'Running' stamp: 'SSS 7/3/2000 13:12'!
run: aResult 
	self tests do: 
		[:each | 
		self sunitChanged: each.
		each run: aResult]! !


!TestSuitesScripter methodsFor: 'Printing' stamp: 'SSS 7/3/2000 13:12'!
printOn: aStream
	aStream nextPutAll: (script isNil 
		ifFalse: [script] 
		ifTrue: ['N/A'])! !

!TestSuitesScripter methodsFor: 'Private' stamp: 'SSS 7/3/2000 13:13'!
executeSingleSuiteScript: aString 
	| useHierachy realName testCase |
	aString last = $*
		ifTrue: 
			[realName := aString copyFrom: 1 to: aString size - 1.
			useHierachy := true]
		ifFalse: 
			[realName := aString.
			useHierachy := false].
	realName isEmpty ifTrue: [^nil].
	testCase := SUnitNameResolver classNamed: realName sunitAsSymbol.
	testCase isNil ifTrue: [^nil].
	^useHierachy
		ifTrue: [self hierachyOfTestSuitesFrom: testCase]
		ifFalse: [testCase suite]! !

!TestSuitesScripter methodsFor: 'Private' stamp: 'SSS 7/3/2000 13:13'!
getNextToken
	[stream atEnd not and: [stream peek first = $"]] whileTrue: [self skipComment].
	^stream atEnd not
		ifTrue: [stream next]
		ifFalse: [nil]! !

!TestSuitesScripter methodsFor: 'Private' stamp: 'SSS 7/3/2000 13:13'!
hierachyOfTestSuitesFrom: aTestCase 
	| subSuite |
	subSuite := TestSuite new.
	subSuite addTest: aTestCase suite.
	aTestCase allSubclasses do: [:each | subSuite addTest: each sunitName sunitAsSymbol sunitAsClass suite].
	^subSuite! !

!TestSuitesScripter methodsFor: 'Private' stamp: 'SSS 7/3/2000 13:14'!
setScript: aString
	script := aString! !

!TestSuitesScripter methodsFor: 'Private' stamp: 'SSS 7/3/2000 13:14'!
skipComment
	| token inComment |
	token := stream next.
	token size > 1 & (token last = $") ifTrue: [^nil].
	inComment := true.
	[inComment & stream atEnd not]
		whileTrue: 
			[token := stream next.
			token last = $" ifTrue: [inComment := false]]! !

!TestSuitesScripter methodsFor: 'Running' stamp: 'SSS 7/3/2000 13:15'!
run: aString
	| suite subSuite token |
	suite := TestSuite new.
	stream := ReadStream on: aString sunitSubStrings. 
	[stream atEnd] whileFalse: 
		[token := self getNextToken.
		token notNil ifTrue: [
			subSuite := self executeSingleSuiteScript: token.
			subSuite notNil ifTrue:[suite addTest: subSuite]]].
	^suite! !

!TestSuitesScripter methodsFor: 'Running' stamp: 'SSS 7/3/2000 13:15'!
value
	^self run: script! !


!TestSuitesScripter class methodsFor: 'Example' stamp: 'SSS 7/3/2000 13:16'!
exampleScripting
	(TestSuitesScripter script: ' "scratch suite 3" ExampleSetTest SUnitTest* ') value! !

!TestSuitesScripter class methodsFor: 'Init / Release' stamp: 'SSS 7/3/2000 13:16'!
run: aString
	^self new run: aString! !

!TestSuitesScripter class methodsFor: 'Init / Release' stamp: 'SSS 7/3/2000 13:17'!
script: aString
	^self new setScript: aString! !

