'From Squeak2.8 of 13 June 2000 [latest update: #2359] on 23 August 2000 at 10:37:11 pm'!
TestCase subclass: #ExampleSetTest
	instanceVariableNames: 'full empty '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!
TestCase subclass: #SUnitTest
	instanceVariableNames: 'hasRun hasSetup hasRanOnce '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!
SUnitTest subclass: #TestSuitesHierarchyScriptTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!
TestSuitesHierarchyScriptTest subclass: #TestSuitesCompoundScriptTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!
SUnitTest subclass: #TestSuitesScriptTest
	instanceVariableNames: 'scripter suite '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!

!ExampleSetTest methodsFor: 'Running' stamp: 'SSS 7/5/2000 13:31'!
setUp
	empty := Set new.
	full := Set with: 5 with: #abc! !

!ExampleSetTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:32'!
testAdd
	empty add: 5.
	self assert: (empty includes: 5)! !

!ExampleSetTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:32'!
testGrow
	empty addAll: (1 to: 100).
	self assert: empty size = 100! !

!ExampleSetTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:32'!
testIllegal
	self 
		should: [empty at: 5] 
		raise: TestResult error.
	self 
		should: [empty at: 5 put: #abc] 
		raise: TestResult error! !

!ExampleSetTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:32'!
testIncludes
	self assert: (full includes: 5).
	self assert: (full includes: #abc)! !

!ExampleSetTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:33'!
testOccurrences
	self assert: (empty occurrencesOf: 0) = 0.
	self assert: (full occurrencesOf: 5) = 1.
	full add: 5.
	self assert: (full occurrencesOf: 5) = 1! !

!ExampleSetTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:33'!
testRemove
	full remove: 5.
	self assert: (full includes: #abc).
	self deny: (full includes: 5)! !


!SUnitTest methodsFor: 'Accessing' stamp: 'SSS 7/5/2000 13:33'!
hasRun
	^hasRun! !

!SUnitTest methodsFor: 'Accessing' stamp: 'SSS 7/5/2000 13:34'!
hasSetup
	^hasSetup! !

!SUnitTest methodsFor: 'Private' stamp: 'SSS 7/5/2000 13:34'!
error
	3 zork! !

!SUnitTest methodsFor: 'Private' stamp: 'SSS 7/5/2000 13:34'!
fail
	self assert: false! !

!SUnitTest methodsFor: 'Private' stamp: 'SSS 7/5/2000 13:34'!
noop! !

!SUnitTest methodsFor: 'Private' stamp: 'SSS 7/5/2000 13:35'!
setRun
	hasRun := true! !

!SUnitTest methodsFor: 'Running' stamp: 'SSS 7/5/2000 13:35'!
setUp
	hasSetup := true! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:35'!
testAssert
	self assert: true.
	self deny: false! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:36'!
testDebugUI
	"This should break"
	3 zork! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:36'!
testDefects
	| result suite error failure |
	suite := TestSuite new.
	suite addTest: (error := self class selector: #error).
	suite addTest: (failure := self class selector: #fail).
	result := suite run.
	self assert: result defects asArray = (Array with: error with: failure)! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:36'!
testDialectLocalizedException
	self should: [TestResult signalFailureWith: 'Foo'] raise: TestResult failure.
	self should: [TestResult signalErrorWith: 'Foo'] raise: TestResult error.
	self shouldnt: [TestResult signalErrorWith: 'Foo'] raise: TestResult failure.! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:37'!
testError
	| case result |
	case := self class selector: #error.
	result := case run.
	self assert: result correctCount = 0.
	self assert: result failureCount = 0.
	self assert: result runCount = 1.
	self assert: result errorCount = 1! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:37'!
testException
	self should: [self error: 'foo'] raise: TestResult error! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:37'!
testFail
	| case result |
	case := self class selector: #fail.
	result := case run.
	self assert: result correctCount = 0.
	self assert: result failureCount = 1.
	self assert: result runCount = 1! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:37'!
testFailureDebugUI
	"This should fail !!"
	self fail! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:38'!
testIsNotRerunOnDebug
	| case |
	case := self class selector: #testRanOnlyOnce.
	case run.
	case debug! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:38'!
testRan
	| case |
	case := self class selector: #setRun.
	case run.
	self assert: case hasSetup.
	self assert: case hasRun! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:38'!
testRanOnlyOnce
	self assert: hasRanOnce ~= true.
	hasRanOnce := true.! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:38'!
testResult
	| case result |
	case := self class selector: #noop.
	result := case run.
	self assert: result runCount = 1.
	self assert: result correctCount = 1! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:38'!
testRunning
	(SUnitDelay forSeconds: 2) wait! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:38'!
testShould
	self should: [true].
	self shouldnt: [false]! !

!SUnitTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:39'!
testSuite
	| suite result |
	suite := TestSuite new.
	suite addTest: (self class selector: #noop).
	suite addTest: (self class selector: #fail).
	result := suite run.
	self assert: result runCount = 2.
	self assert: result correctCount = 1.
	self assert: result failureCount = 1! !


!TestSuitesHierarchyScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:39'!
testRan
	self setRun! !


!TestSuitesCompoundScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:40'!
testRan
	super testRan! !


!TestSuitesScriptTest methodsFor: 'Running' stamp: 'SSS 7/5/2000 13:40'!
setUp
	scripter := TestSuitesScripter new.! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:40'!
testCompoundScript
	| allTestCaseClasses superCase subCase |
	allTestCaseClasses := (scripter run: 'TestSuitesHierarchyScriptTest TestSuitesCompoundScriptTest') tests. 
	self assert: allTestCaseClasses size = 2.
	superCase := (allTestCaseClasses at: 1) tests first.
	self assert: superCase class sunitName sunitAsSymbol = #TestSuitesHierarchyScriptTest.
	subCase := (allTestCaseClasses at: 2) tests first.
	self assert: subCase class sunitName sunitAsSymbol = #TestSuitesCompoundScriptTest.! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:41'!
testEmbeddedNameCommentScript
	suite := scripter run: ' "This comment contains the name of a SUnitTest Case"  TestSuitesScriptTest'.
	self assert: suite tests size = 1! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:41'!
testEmptyCommentScript
	suite := scripter run: ' " " TestSuitesScriptTest'.
	self assert: suite tests size = 1! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:41'!
testEmptyHierachyScript
	suite := scripter run: '*'.
	self assert: suite tests isEmpty! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:42'!
testEmptyScript
	suite := scripter run: ''.
	self assert: suite tests isEmpty! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:42'!
testHierachyScript
	| allTestCaseClasses superCase subCase |
	suite := scripter run: 'TestSuitesHierarchyScriptTest*'.
	allTestCaseClasses := suite tests. 
	self assert: allTestCaseClasses size = 1.
	superCase := (allTestCaseClasses first tests at: 1) tests first.
	self assert: superCase class sunitName sunitAsSymbol = #TestSuitesHierarchyScriptTest.
	subCase := (allTestCaseClasses first tests at: 2) tests first.
	self assert: subCase class sunitName sunitAsSymbol = #TestSuitesCompoundScriptTest.! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:42'!
testOpenCommentScript
	suite := scripter run: ' "SUnitTest'.
	self assert: suite tests isEmpty! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:42'!
testSimpleScript
	| allTestCaseClasses case |
	suite := scripter run: 'TestSuitesHierarchyScriptTest'.
	allTestCaseClasses := suite tests.
	self assert: allTestCaseClasses size = 1.
	case := (allTestCaseClasses at: 1) tests at: 1.
	self assert: case class sunitName sunitAsSymbol = #TestSuitesHierarchyScriptTest.! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:42'!
testSingleWordCommentScript
	suite := scripter run: ' "SUnitTest" TestSuitesScriptTest'.
	self assert: suite tests size = 1! !

!TestSuitesScriptTest methodsFor: 'Testing' stamp: 'SSS 7/5/2000 13:43'!
testTwoCommentsScript
	suite := scripter run: ' " SUnitTest "  " SUnitTest " TestSuitesScriptTest'.
	self assert: suite tests size = 1! !

